/*****************************************************************************
**
** create_auto_block.c
**
** :
**              
**		,      .
**
*****************************************************************************/

#define _CRT_SECURE_NO_DEPRECATE 1

/* Include files */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <uf.h>
#include <uf_ui.h>
#include <uf_modl.h>
#include <uf_csys.h>
#include <uf_disp.h>

#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))

static int init_proc(UF_UI_selection_p_t select, void *user_data);

static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133],
             msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ",
            irc, line, file);
        UF_get_fail_message(irc, err);

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}

/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	tag_t workpice, view, blk_obj;
	double bounding_box[6], cursor[3], block_orig[3], directions[3][3], distances[3];
	int scope = UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
	int sign = UF_NULLSIGN;
	int response, irc;
	char *block_len[3] = {"1","2","3"};
	char tmp_str[256];

    /* Initialize the API environment */
	if(UF_CALL(UF_initialize())) { return; }
	
/*        */
/*       */
	irc = UF_UI_select_with_single_dialog(" ", " ", 
		scope, init_proc, NULL, &response, &workpice, cursor, &view);
/*    */
	UF_MODL_ask_bounding_box_exact(workpice, NULL_TAG, 
		block_orig, directions, distances);
/*      */
	sprintf(tmp_str, "%lf", distances[0]);
	block_len[0] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[0], tmp_str);
	sprintf(tmp_str, "%lf", distances[1]);
	block_len[1] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[1], tmp_str);
	sprintf(tmp_str, "%lf", distances[2]);
	block_len[2] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[2], tmp_str);
/*   */
	UF_CALL(UF_MODL_create_block1(sign, block_orig, block_len, &blk_obj));
/*     */
	UF_DISP_set_highlight(workpice, 0);

    /*   */
    UF_CALL(UF_terminate());
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

/*      */
static int init_proc(UF_UI_selection_p_t select, void *user_data)
{
    int num_triples = 1;
    UF_UI_mask_t mask_triples[] = 
	{
		UF_solid_type, 0, UF_UI_SEL_FEATURE_BODY
	};
    if((UF_UI_set_sel_mask(select,
            UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
            num_triples, mask_triples)) == 0)
    {
        return (UF_UI_SEL_SUCCESS);
    }
    else
    {
        return (UF_UI_SEL_FAILURE);
    }
}
