//////////////////////////////////////////////////////////////////////////////
//
//  create_auto_block.cpp
//
//  Description:
//      Contains Unigraphics entry points for the application.
//
//////////////////////////////////////////////////////////////////////////////

/*****************************************************************************
**
** create_auto_block.c
**
** :
**             
**		,      .
**
*****************************************************************************/

#define _CRT_SECURE_NO_DEPRECATE 1

/* Include files */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>

//  Include files
#include <uf.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_part.h>
#include <uf_modl.h>
//#include <uf_csys.h>
#include <uf_disp.h>

/*
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#	include <strstream>
	using std::ostrstream;
	using std::endl;
	using std::ends;
#else
#	include <strstream.h>
#endif
#include <iostream.h>
*/
#include "create_auto_block.h"


#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))

static int report_error( char *, int , char *, int );
static int init_proc(UF_UI_selection_p_t select, void *user_data);
int create_auto_block( );

static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133],  msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ", irc, line, file);
        UF_get_fail_message(irc, err);

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}

/*      */
static int init_proc(UF_UI_selection_p_t select, void *user_data)
{
    int num_triples = 1;
    UF_UI_mask_t mask_triples[] =
	{
		UF_solid_type, 0, UF_UI_SEL_FEATURE_BODY
	};
    if((UF_UI_set_sel_mask(select,
            UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
            num_triples, mask_triples)) == 0)
    {
        return (UF_UI_SEL_SUCCESS);
    }
    else
    {
        return (UF_UI_SEL_FAILURE);
    }
}

int create_auto_block( )
{
	tag_t workpice, view, blk_obj;
	double cursor[3];
	double block_orig[3], directions[3][3], distances[3];
	int scope ;
	UF_FEATURE_SIGNS sign = UF_NULLSIGN;
	int response, irc;
	char *block_len[3] = {"1","2","3"};
	char tmp_str[256];
	
	/********************************************************************************/
  int i;
  char menu[3][16]; double  da[3];
  /********************************************************************************/
  char *mes1[]={
      "    -. (   NX4)",
      " ,     . ",
      NULL
  };
  UF_UI_message_buttons_t buttons1 = { TRUE, FALSE, TRUE, "....", NULL, "", 1, 0, 2 };

  response=0;
  UF_UI_message_dialog("create_auto_block.....", UF_UI_MESSAGE_INFORMATION, mes1, 2, TRUE, &buttons1, &response);
  if (response!=1) { return (0) ; }

  /* Ask displayed part tag */
  if (NULL_TAG==UF_PART_ask_display_part()) {
      uc1601("  .....\n  .",1);
      return (0);
  }
  /********************************************************************************/

/*              */
	scope = UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
	irc = UF_UI_select_with_single_dialog(" ", " ",
		scope, init_proc, NULL, &response, &workpice, cursor, &view);
  if ((response==UF_UI_BACK)||(response==UF_UI_CANCEL)) return (0);
  if (workpice==null_tag) return (0);

/*    -    NX4*/
	UF_CALL( UF_MODL_ask_bounding_box_exact(workpice, NULL_TAG, block_orig, directions, distances) );

  /********************************************************************************/  
    strcpy(&menu[0][0], ". =\0");
    strcpy(&menu[1][0], ".=\0");
    strcpy(&menu[2][0], ".=\0");
    for (i=0;i<3;i++) da[i]=distances[i];
    response = uc1609(" ..", menu, 3, da, &irc);
    if (response == 3 || response == 4) { for (i=0;i<3;i++) distances[i]=fabs(da[i]); }
  /********************************************************************************/

/*      */
	sprintf(tmp_str, "%lf", distances[0]);
	block_len[0] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[0], tmp_str);
	sprintf(tmp_str, "%lf", distances[1]);
	block_len[1] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[1], tmp_str);
	sprintf(tmp_str, "%lf", distances[2]);
	block_len[2] = (char *)malloc((sizeof(char)*strlen(tmp_str))+1);
	strcpy(block_len[2], tmp_str);

/*   */
	UF_CALL(UF_MODL_create_block1(sign, block_orig, block_len, &blk_obj));
	if (blk_obj==null_tag) {
		uc1601 ("  -",1);
	}

/*   c  */
	UF_CALL(UF_DISP_set_highlight(workpice, 0));

	return (0);

}


//----------------------------------------------------------------------------
//  Activation Methods
//----------------------------------------------------------------------------

//  Explicit Activation
//      This entry point is used to activate the application explicitly, as in
//      "File->Execute UG/Open->User Function..."
extern "C" DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    /* Initialize the API environment */
    int errorCode = UF_initialize();

    if ( 0 == errorCode )
    {
        /* TODO: Add your application code here */
        create_auto_block();

        /* Terminate the API environment */
        errorCode = UF_terminate();
    }

    /* Print out any error messages */
    PrintErrorMessage( errorCode );
    *returnCode=0;
}

//----------------------------------------------------------------------------
//  Utilities
//----------------------------------------------------------------------------

// Unload Handler
//     This function specifies when to unload your application from Unigraphics.
//     If your application registers a callback (from a MenuScript item or a
//     User Defined Object for example), this function MUST return
//     "UF_UNLOAD_UG_TERMINATE".
extern "C" int ufusr_ask_unload( void )
{
     /* unload immediately after application exits*/
     return ( UF_UNLOAD_IMMEDIATELY );

     /*via the unload selection dialog... */
     //return ( UF_UNLOAD_SEL_DIALOG );
     /*when UG terminates...              */
     /*return ( UF_UNLOAD_UG_TERMINATE ); */
}

/* PrintErrorMessage
**
**     Prints error messages to standard error and the Unigraphics status
**     line. */
static void PrintErrorMessage( int errorCode )
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( stderr, "%s\n", message );
    }
}

